unit umain;
{
 * This Source Code Form is subject to the terms of the Mozilla Public License,
 * v. 2.0. If a copy of the MPL was not distributed with this file, You can
 * obtain one at http://mozilla.org/MPL/2.0/
 *
 * Copyright (C) 2013, Robert W.B. Linn, Pinneberg, Germany (www.rwblinn.de).
 *
 * See readme.txt for latest information.
}

(*
********************************************************************************
  SQLite Sample application
  Notes:
  Requires sqlite3.dll. This must be placed in your path - best in:
  ..\windows\system32
  Books Table fields; _id, title, author, isbn, description, category
********************************************************************************
*)

interface

uses
  Winapi.Windows, Winapi.Messages,
  System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Data.DbxSqlite,
  Vcl.StdCtrls, Data.DB, Data.SqlExpr, Data.DBXMySQL, Data.FMTBcd, Vcl.ExtCtrls,
  Vcl.DBCtrls, Vcl.Grids, Vcl.DBGrids, Datasnap.Provider, System.Actions,
  Vcl.ActnList, ClipBrd, ShellAPI, Datasnap.DBClient, Vcl.ComCtrls, Vcl.ToolWin,
  Vcl.ImgList;

const
  CCRLF = Chr(13) + Chr(10);
  CCRLF2 = CCRLF + CCRLF;

const
  CPRODUCTNAME = 'ropBookLib';
  CVERSION = 'v1.1 (Build: 20130820)';
  CAUTHORNAME = 'Robert W.B. Linn, Pinneberg, Germany';
  CAUTHORMAILTO = 'mailto:robert@rwblinn.de';
  CHOMEPAGENAME = 'www.rwblinn.de';
  CHOMEPAGEURL = 'http://www.rwblinn.de';
  CCOPYRIGHT = 'Copyright (c) 2013 Robert W.B. Linn';
  CCOPYRIGHTHTML =
    'Copyright &copy; 2013 <a href="http://www.rwblinn.de">Robert W.B. Linn</a> (Pinneberg, Germany). All Rights Reserved!';
  CINTERNET = 'http://www.rwblinn.de';
  CCOMMENTS = 'Customize your Code Library.';
  CPGMINFO = CPRODUCTNAME + ' ' + CVERSION + CCRLF2 + CCOPYRIGHT + CCRLF2 +
    'Die Software darf unter Einhaltung der "GNU General Public License" ' +
    'Lizenzbestimmungen (siehe www.gnu.org/licenses) und ' +
    'Hinweis auf den Urheber beliebig verwendet und weiter gegeben werden.' +
    'Weitere Information www.rwblinn.de';
  CINTERNETS = 'rwblinn.de';

type
  TfrmMain = class(TForm)
    SQLConnection1: TSQLConnection;
    ActionList1: TActionList;
    ActionSQLConnect: TAction;
    ActionSQLExecute: TAction;
    ActionDBFieldnames: TAction;
    ActionSQLResults: TAction;
    pcMain: TPageControl;
    tsSQL: TTabSheet;
    memoOutput: TMemo;
    Splitter1: TSplitter;
    tsTable: TTabSheet;
    sgSQLResults: TStringGrid;
    ActionSQLResultsToStringGrid: TAction;
    ActionGridMoveToPrev: TAction;
    ActionGridMoveToNext: TAction;
    ActionGridShowCurrent: TAction;
    ActionGridEntryDelete: TAction;
    ActionGridMoveToFirst: TAction;
    ActionGridMoveToLast: TAction;
    ToolBar1: TToolBar;
    ToolButton5: TToolButton;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton6: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    pnlButtons: TPanel;
    connectButton: TButton;
    Button1: TButton;
    lbFieldnames: TListBox;
    ActionGridToForm: TAction;
    pnlBookForm: TPanel;
    ledTitle: TLabeledEdit;
    ledAuthor: TLabeledEdit;
    ledISBN: TLabeledEdit;
    ledDescription: TLabeledEdit;
    ActionGridEntryInsert: TAction;
    ActionGridEntryUpdate: TAction;
    ledID: TLabeledEdit;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ImageList1: TImageList;
    ActionAbout: TAction;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    cbSQLCommand: TComboBox;
    lblNoRecords: TLabel;
    Button2: TButton;
    ActionExit: TAction;
    ToolButton14: TToolButton;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ActionSQLConnectExecute(Sender: TObject);
    procedure ActionSQLExecuteExecute(Sender: TObject);
    procedure ActionDBFieldnamesExecute(Sender: TObject);
    procedure ActionSQLResultsExecute(Sender: TObject);
    procedure lbFieldnamesDblClick(Sender: TObject);
    procedure lblCopyrightClick(Sender: TObject);
    procedure ActionSQLResultsToStringGridExecute(Sender: TObject);
    procedure pcMainChange(Sender: TObject);
    procedure ActionGridMoveToPrevExecute(Sender: TObject);
    procedure ActionGridMoveToNextExecute(Sender: TObject);
    procedure ActionGridEntryDeleteExecute(Sender: TObject);
    procedure ActionGridShowCurrentExecute(Sender: TObject);
    procedure ActionGridMoveToFirstExecute(Sender: TObject);
    procedure ActionGridMoveToLastExecute(Sender: TObject);
    procedure sgSQLResultsSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure ActionGridEntryInsertExecute(Sender: TObject);
    procedure ActionGridEntryUpdateExecute(Sender: TObject);
    procedure ActionAboutExecute(Sender: TObject);
    procedure cbSQLCommandChange(Sender: TObject);
    procedure cbSQLCommandDropDown(Sender: TObject);
    procedure cbSQLCommandKeyPress(Sender: TObject; var Key: Char);
    procedure Button2Click(Sender: TObject);
    procedure sgSQLResultsFixedCellClick(Sender: TObject; ACol, ARow: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ActionExitExecute(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    FDBSQL: String;
    FDSSQLResults: TDataSet;
    Procedure SQLExecute(Sender: TObject; sSQL: String);
    Function  SQLIsTableExists(Sender: TObject; sTablename: String): Boolean;
    Procedure SQLSystemUpdate(Sender: TObject; sSection, sKey, sValue: String);
    Function  SQLSystemRead(Sender: TObject; sSection, sKey, sDefault : String): String;
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

Uses uaboutbox;

Var
  nFilterIdx: Integer;

// ******************************************************************************
// FORM
// ******************************************************************************
procedure TfrmMain.FormCreate(Sender: TObject);
Var i : Integer;
begin
  // Output Memo
  memoOutput.Clear;
  // Pagecontrol
  pcMain.ActivePageIndex := 0;
  // SQL Database
  FDBSQL := ExpandFileName(ChangeFileExt(Application.ExeName, '.db'));
  ActionSQLExecute.Enabled := False;
  // Connect to the DB
  ActionSQLConnectExecute(Sender);
  // Set form position
  frmMain.Top := StrToInt(SQLSystemRead(Sender, 'POSITION', 'TOP', '200'));
  frmMain.Left := StrToInt(SQLSystemRead(Sender, 'POSITION', 'LEFT', '200'));
  // Build SQL command list - just some sample commands
  With cbSQLCommand Do Begin
    Items.Clear;
    Items.Add('select * from books');
    Items.Add('select * from books where _id=1');
    Items.Add('select * from books where title="mytitle2"');
    // show all tables in a SQL database
    Items.Add('SELECT name FROM sqlite_master WHERE type=''table''');
    Items.Add('insert into books (title, description) values (''Titel1'', ''Beschreibung Titel 1'')');
    Items.Add('delete from books where title = "Titel1"');
    Items.Add('delete from books where title like ''Titel1%''');
    Items.Add('delete from books where _id > 0');
    Items.Add('select count(*) from books');
    Items.Add('update books set title="Titel1=' + DateTimeToStr(Now) +
      '" where title = ''Titel1''');
    Items.Add('select * from system');
    ItemIndex := 0;
  End;
  // set the colwidth of the stringgrid
  With sgSQLResults Do Begin
    For i := 0 To ColCount - 1 Do
      ColWidths[i] := StrToInt(SQLSystemRead(Sender, 'GRIDCOLWIDTH', 'COL'+IntToStr(i), '64'));
  End;
{ TODO 2 -oRL -cNew : set category column if after category field is used }
  sgSQLResults.ColWidths[5] := 0;
  // Show the fieldnames and the content in the stringgrid for the books table
  ActionDBFieldnamesExecute(Sender);
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
Var i: Integer;
begin
  SQLSystemUpdate(Sender, 'POSITION', 'TOP', IntToStr(frmMain.Top));
  SQLSystemUpdate(Sender, 'POSITION', 'LEFT', IntToStr(frmMain.Left));
  With sgSQLResults Do Begin
    For i := 0 To ColCount - 1 Do
      SQLSystemUpdate(Sender, 'GRIDCOLWIDTH', 'COL'+IntToStr(i), IntToStr(sgSQLResults.ColWidths[i]));
  End;
end;

procedure TfrmMain.lblCopyrightClick(Sender: TObject);
begin
  ShellExecute(Handle, nil, PChar('http://www.rwblinn.de'), nil, nil, SW_SHOW);
end;

procedure TfrmMain.pcMainChange(Sender: TObject);
begin
  // Do nothing for the moment
end;

procedure TfrmMain.sgSQLResultsFixedCellClick(Sender: TObject; ACol,
  ARow: Integer);
Var sSQL: String;
begin
  sSQL := 'select * from books order by ' + sgSQLResults.Cells[ACol, 0] + '';
  SQLExecute(Sender, sSQL);
end;

procedure TfrmMain.sgSQLResultsSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
  If ARow > 0 Then Begin
    ledID.Text := sgSQLResults.Cells[0, ARow];
    ledTitle.Text := sgSQLResults.Cells[1, ARow];
    ledAuthor.Text := sgSQLResults.Cells[2, ARow];
    ledISBN.Text := sgSQLResults.Cells[3, ARow];
    ledDescription.Text := sgSQLResults.Cells[4, ARow];
    // showmessage(sgSQLResults.Cells[ACol, ARow]);
  End;
end;

procedure TfrmMain.lbFieldnamesDblClick(Sender: TObject);
Var
  sStr: String;
  i: Integer;
begin
  If lbFieldnames.Items.Count = 0 Then
    Exit;
  For i := 0 To lbFieldnames.Items.Count - 1 Do
  Begin
    sStr := sStr + lbFieldnames.Items[i] + #13#10;
  End;
  //
  If sStr <> '' Then
    ClipBoard.SetTextBuf(PChar(sStr))
end;

// ******************************************************************************
// SQL
// ******************************************************************************
Procedure TfrmMain.SQLExecute(Sender: TObject; sSQL: String);
Begin
  If sSQL = '' Then
    sSQL := 'SELECT * FROM books;';
  cbSQLCommand.Text := sSQL;
  cbSQLCommandDropDown(Sender);
  // memoOutput.Clear;
  memoOutput.Lines.Add('---');
  memoOutput.Lines.Add('SQL Execute :: ' + sSQL);
  Try
    // Execute the query on the database.
    If Pos('select', LowerCase(sSQL)) > 0 Then Begin
      SQLConnection1.Execute(sSQL, nil, FDSSQLResults);
      // Show the results of the query in a TMemo control
      ActionSQLResultsExecute(Sender);
      // And in a StringGrid
      ActionSQLResultsToStringGridExecute(Sender);
      // BUT if no records found
    End
    Else
    Begin
      // Execute SQL command which does not provide a result, like insert, delete, update
      SQLConnection1.Execute(sSQL, NIL);
    End;
  Except
    on E: Exception do
      memoOutput.Text := 'Exception raised with message: ' + E.Message;
  End;
End;

Function TfrmMain.SQLIsTableExists(Sender: TObject; sTablename: String): Boolean;
Var sSQL: String;
    DS: TDataSet;
Begin
  Result := False;
  If sTablename = '' Then Exit;
  Try
    // Execute the query on the database.
    sSQL := 'SELECT name FROM sqlite_master WHERE type=''table'' AND name=''' + sTablename + '''';
    memoOutput.Lines.Add('SQL Command :: ' + sSQL);
    SQLConnection1.Execute(sSQL, nil, DS);
    memoOutput.Lines.Add('SQL Command :: Tablename = ' + DS.FieldByName('name').AsString);
    If Lowercase(DS.FieldByName('name').AsString) = LowerCase(sTablename) Then
      Result := True;
  Except
    on E: Exception do
      memoOutput.Text := 'Exception raised with message: ' + E.Message;
  End;
End;

// ******************************************************************************
// ACTIONS
// ******************************************************************************
procedure TfrmMain.ActionGridEntryDeleteExecute(Sender: TObject);
Var
  sSQL: String;
  nCol: Integer;
begin
  If sgSQLResults.RowCount < 2 Then
  Begin
    ShowMessage('No results from the SQL command.');
    Exit;
  End;
  If sgSQLResults.RowCount > 1 Then
  Begin
    // ShowMessage('Results from the SQL command.');
  End;
  nCol := 0;
  sSQL := 'delete from books where _id = ' + sgSQLResults.Cells
    [nCol, sgSQLResults.Row];
  SQLExecute(Sender, sSQL);
  ActionSQLResultsToStringGridExecute(Sender);
end;

procedure TfrmMain.ActionGridEntryInsertExecute(Sender: TObject);
Var
  sSQL: String;
begin
  If ledTitle.Text = '' Then
    Exit;
  sSQL := 'insert into books (title, author, isbn, description) values (' +
    '''' + ledTitle.Text + '''' + ',' +
    '''' + ledAuthor.Text + '''' + ',' +
    '''' + ledISBN.Text + '''' + ',' +
    '''' + ledDescription.Text + '''' +
    ')';
  SQLExecute(Sender, sSQL);
  sSQL := 'select * from books';
  SQLExecute(Sender, sSQL);
  sgSQLResults.Row := sgSQLResults.RowCount - 1;
end;

procedure TfrmMain.ActionGridMoveToFirstExecute(Sender: TObject);
begin
  If FDSSQLResults.RecordCount = 0 Then
  Begin
    Exit;
  End;
  sgSQLResults.Row := 1;
end;

procedure TfrmMain.ActionGridMoveToLastExecute(Sender: TObject);
begin
  If FDSSQLResults.RecordCount = 0 Then
  Begin
    Exit;
  End;
  sgSQLResults.Row := sgSQLResults.RowCount - 1;
end;

procedure TfrmMain.ActionGridMoveToNextExecute(Sender: TObject);
begin
  With sgSQLResults Do
  Begin
    // ShowMessage('RowCount ' + IntToStr(RowCount));
    If Row < RowCount - 1 Then
    Begin
      // ShowMessage('Row < RowCount ' + IntToStr(Row));
      Row := Row + 1;
      Exit;
    End;
    If Row = RowCount - 1 Then
    Begin
      // ShowMessage('Row = RowCount ' + IntToStr(Row));
      Row := 1;
      Exit;
    End;
  End;
end;

procedure TfrmMain.ActionGridMoveToPrevExecute(Sender: TObject);
begin
  With sgSQLResults Do
  Begin
    // ShowMessage('RowCount ' + IntToStr(RowCount));
    If Row > 1 Then
    Begin
      // ShowMessage('Row < RowCount ' + IntToStr(Row));
      Row := Row - 1;
      Exit;
    End;
    If Row = 1 Then
    Begin
      // ShowMessage('Row = RowCount ' + IntToStr(Row));
      Row := RowCount - 1;
      Exit;
    End;
  End;
end;

procedure TfrmMain.ActionGridShowCurrentExecute(Sender: TObject);
Var
  nCol: Integer;
  sStr: String;
begin
  If sgSQLResults.RowCount < 2 Then
  Begin
    ShowMessage('No results from the SQL command.');
    Exit;
  End;
  If sgSQLResults.RowCount > 1 Then
  Begin
    // ShowMessage('Results from the SQL command.');
  End;
  sStr := '';
  With sgSQLResults Do
  Begin
    For nCol := 0 To ColCount - 1 Do
      sStr := sStr + sgSQLResults.Cells[nCol, Row] + #13#10;
  End;
  ShowMessage(sStr);
end;

procedure TfrmMain.ActionGridEntryUpdateExecute(Sender: TObject);
Var
  sSQL: String;
  nRow: Integer;
begin
  If ledID.Text = '' Then
    Exit;
  If ledTitle.Text = '' Then
    Exit;
  nRow := sgSQLResults.Row;
  sSQL := 'update books ' +
    'set ' +
    'title=' + '''' + ledTitle.Text + '''' + ', ' +
    'author=' + '''' + ledAuthor.Text + '''' + ', ' +
    'isbn=' + '''' + ledISBN.Text + '''' + ', ' +
    'description=' + '''' + ledDescription.Text + '''' +
    ' where _id = ' +
    ledID.Text;
  SQLExecute(Sender, sSQL);
  sSQL := 'select * from books';
  SQLExecute(Sender, sSQL);
  sgSQLResults.Row := nRow
end;

procedure TfrmMain.ActionSQLConnectExecute(Sender: TObject);
begin
  // Set the path of your database file.
  // Replace "full_path_to_your_database_file" with the absolute path
  // to your SQLite database file.
  Try
    // memoOutput.Clear;
    memoOutput.Lines.Add('SQL Connect :: Set parameter Connectionname, Parameter');
    SQLConnection1.ConnectionName := 'SQLConnect';
    SQLConnection1.Params.Add('Database=' + FDBSQL);
    // Establish the connection.
    memoOutput.Lines.Add('SQL Connect :: Database = ' + FDBSQL);
    memoOutput.Lines.Add('SQL Connect :: Establish Connection');
    SQLConnection1.Connected := true;
    ActionSQLExecute.Enabled := true;
    memoOutput.Lines.Add('SQL Connect :: Connection established!');
  Except
    on E: EDatabaseError do
      ShowMessage('Exception raised with message' + E.Message);
  end;
end;

procedure TfrmMain.ActionSQLExecuteExecute(Sender: TObject);
// Execute SQL statement from the listbox
begin
  If cbSQLCommand.Text = '' Then
    Exit;
  SQLExecute(Sender, cbSQLCommand.Text);
end;

procedure TfrmMain.ActionAboutExecute(Sender: TObject);
begin
  With TfrmAboutBox.Create(nil) do
    Try
      Caption := 'About...';
      ProductName.Caption := CPRODUCTNAME + ' ' + CVERSION;
      FAuthorName := CAUTHORNAME;
      FAuthorMailTo := CAUTHORMAILTO;
      FHomepageName := CHOMEPAGENAME;
      FHomepageURL := CHOMEPAGEURL;
      lblAuthorName.Caption := FAuthorName;
      lblHomepageURL.Caption := FHomepageName;
      ShowModal;
    Finally
      Free;
    End;
  (*
    Application.MessageBox(
    PChar(PChar(CPGMINFO)),
    PChar('Info'),
    MB_OK + MB_ICONINFORMATION);
  *)
end;

procedure TfrmMain.ActionDBFieldnamesExecute(Sender: TObject);
begin
  SQLExecute(Sender, 'select * from books');
  If Not FDSSQLResults.IsEmpty then begin
    FDSSQLResults.GetFieldNames(lbFieldnames.Items);
  End;
end;

procedure TfrmMain.ActionExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.ActionSQLResultsExecute(Sender: TObject);
var
  fSLNames: TStringList;
  i: Integer;
  currentField: TField;
  currentLine: string;
begin
  If FDSSQLResults.IsEmpty = True Then Begin
    memoOutput.Lines.Add('SQL Results :: No results from the SQL command.');
    //Exit;
  End;
  If Not FDSSQLResults.IsEmpty then begin
    memoOutput.Lines.Add('SQL Results :: ' + IntToStr(FDSSQLResults.RecordCount));
    FDSSQLResults.First;
    fSLNames := TStringList.Create;
    FDSSQLResults.GetFieldNames(fSLNames);
    While NOT FDSSQLResults.Eof Do Begin
      currentLine := '';
      For i := 0 To fSLNames.Count - 1 Do Begin
        currentField := FDSSQLResults.FieldByName(fSLNames[i]);
        currentLine := currentLine + ' ' + currentField.AsString;
      End;
      memoOutput.Lines.Add(currentLine);
      FDSSQLResults.Next;
    End;
  End;
  memoOutput.Lines.Add('---');
end;

procedure TfrmMain.ActionSQLResultsToStringGridExecute(Sender: TObject);
Var
  i, nCol, nLin: Integer;
begin
  With sgSQLResults Do Begin
    For i := 0 To ColCount - 1 Do
      SQLSystemUpdate(Sender, 'GRIDCOLWIDTH', 'COL'+IntToStr(i), IntToStr(sgSQLResults.ColWidths[i]));
  End;
  // set defaults
  sgSQLResults.ColCount := 0;
  sgSQLResults.RowCount := 0;
  sgSQLResults.FixedCols := 0;
  // sgSQLResults.FixedRows := 1;
  // do nothing if no records found
  pcMain.ActivePageIndex := 1;
  lblNoRecords.Visible := False;
  sgSQLResults.Visible := True;
  If FDSSQLResults.RecordCount = 0 Then Begin
    lblNoRecords.Visible := True;
    sgSQLResults.Visible := False;
    Exit;
  End;
  // Records found - show these
  If Not FDSSQLResults.IsEmpty Then Begin
    sgSQLResults.ColCount := FDSSQLResults.FieldCount;
    sgSQLResults.RowCount := FDSSQLResults.RecordCount + 1;
    sgSQLResults.FixedCols := 0;
    sgSQLResults.FixedRows := 1;
    // set the column width
    With sgSQLResults Do Begin
      For i := 0 To ColCount - 1 Do
        ColWidths[i] := StrToInt(SQLSystemRead(Sender, 'GRIDCOLWIDTH', 'COL'+IntToStr(i), '64'));
    End;
    // set the column headings
    For nCol := 0 To FDSSQLResults.FieldCount - 1 Do
      sgSQLResults.Cells[nCol, 0] := FDSSQLResults.Fields[nCol].FieldName;
    nLin := 0;
    // Loop thru the data and display in the grid
    FDSSQLResults.First;
    While Not FDSSQLResults.Eof Do Begin
      For nCol := 0 To FDSSQLResults.FieldCount - 1 Do Begin
        sgSQLResults.Cells[nCol, nLin + sgSQLResults.FixedRows] :=
          FDSSQLResults.Fields[nCol].AsString;
      End;
      FDSSQLResults.Next;
      Inc(nLin);
    End;
  End;
end;

procedure TfrmMain.Button2Click(Sender: TObject);
begin
  SQLIsTableExists(Sender, 'books');
end;

procedure TfrmMain.cbSQLCommandChange(Sender: TObject);
begin
  nFilterIdx := cbSQLCommand.ItemIndex;
end;

procedure TfrmMain.cbSQLCommandDropDown(Sender: TObject);
Var
  i: Integer;
begin
  With cbSQLCommand Do
  begin
    If Text = '' Then
    Begin
      Items.Delete(nFilterIdx);
      nFilterIdx := -1;
    End
    Else
    Begin
      For i := 0 To Items.Count - 1 Do
        If Text = Items[i] Then
          Exit;
      Items.Add(Text);
    End;
  end;
end;

procedure TfrmMain.cbSQLCommandKeyPress(Sender: TObject; var Key: Char);
begin
  If Key = #13 Then Begin
    cbSQLCommandDropDown(Sender);
    ActionSQLExecuteExecute(Sender);
  End;
end;

procedure TfrmMain.SQLSystemUpdate(Sender: TObject; sSection, sKey, sValue: String);
Var sSQL: String;
    DS: TDataSet;
begin
  Try
    sSQL := 'select sysvalue from system where ' +
            'syssection=' + '''' + sSection + '''' +
            ' AND ' +
            'syskey=' + '''' + sKey + '''' + '';
    SQLConnection1.Execute(sSQL, nil, DS);
    If DS.FieldByName('sysvalue').AsString = '' Then Begin
      sSQL := 'insert into system (syssection, syskey, sysvalue) values (' +
              '''' + sSection + '''' + ', ' +
              '''' + sKey + '''' + ', ' +
              '''' + sValue + '''' + ')';
      SQLConnection1.Execute(sSQL, nil);
    End Else Begin
      sSQL := 'update system ' +
              'set ' +
              'syssection=' + '''' + sSection + '''' + ', ' +
              'syskey=' + '''' + sKey + '''' + ', ' +
              'sysvalue=' + '''' + sValue + '''' +
              ' where ' +
              'syssection=' + '''' + sSection + '''' + ' AND ' +
              'syskey=' + '''' + sKey + '''' + '';
      SQLConnection1.Execute(sSQL, nil);
    End;
  Except
    on E: Exception do
      memoOutput.Text := 'Exception raised with message: ' + E.Message;
  End;
end;

Function TfrmMain.SQLSystemRead(Sender: TObject; sSection, sKey, sDefault : String): String;
Var sSQL: String;
    DS: TDataSet;
begin
  Result := sDefault;
  Try
    sSQL := 'select sysvalue from system where ' +
            'syssection=' + '''' + sSection + '''' +
            ' AND ' +
            'syskey=' + '''' + sKey + '''' + '';
    SQLConnection1.Execute(sSQL, nil, DS);
    Result := DS.FieldByName('sysvalue').AsString;
    If Result = '' Then
      Result := sDefault;
  Except
    on E: Exception do
      memoOutput.Text := 'Exception raised with message: ' + E.Message;
  End;
end;

end.

