unit umain;
{
 * This Source Code Form is subject to the terms of the Mozilla Public License,
 * v. 2.0. If a copy of the MPL was not distributed with this file, You can
 * obtain one at http://mozilla.org/MPL/2.0/
 *
 * Copyright (C) 2013, Robert W.B. Linn, Pinneberg, Germany (www.rwblinn.de).
 *
}

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Data.FMTBcd, DataSnap.DBClient,
  System.Actions, Vcl.ActnList, Vcl.Grids, Data.DB, Data.SqlExpr,
  Data.Bind.Components, Data.Bind.DBScope, Data.Bind.DBXScope, Vcl.StdCtrls,
  Vcl.ExtCtrls, Data.Bind.EngExt, Vcl.Bind.DBEngExt, Vcl.Bind.Grid, System.Rtti,
  System.Bindings.Outputs, Vcl.Bind.Editors, Data.Bind.Grid, Data.DbxSqlite;

Const
  CTESTDB = 'buecher.db';

type
  TfrmMain = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    edSQLiteDBPath: TEdit;
    Button1: TButton;
    ActionList1: TActionList;
    BindSourceDBX: TBindSourceDBX;
    SQLConnection: TSQLConnection;
    StringGrid1: TStringGrid;
    ActionSQLiteDBConnect: TAction;
    BindingsList1: TBindingsList;
    LinkGridToDataSource1: TLinkGridToDataSource;
    procedure FormCreate(Sender: TObject);
    procedure ActionSQLiteDBConnectExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  // Deactivate all connections
  // SQLConnection.Connected := False;
  // BindSourceDBX.Active    := SQLConnection.Connected;
  // Init input & output fields
  edSQLiteDBPath.Text := ExtractFilePath(Application.ExeName) + CTESTDB;
end;

//******************************************************************************
// Actions
//******************************************************************************

procedure TfrmMain.ActionSQLiteDBConnectExecute(Sender: TObject);
// SQLite DB connect
begin
  // Checks
  If Not FileExists(edSQLiteDBPath.Text) Then Begin
    ShowMessage('Fehler SQLite Datenbankverbindung: Datenbank nicht gefunden!' + #13#10#13#10 +
                edSQLiteDBPath.Text);
    Exit;
  End;
  Try
    With SQLConnection Do Begin
      Connected := False;
      BindSourceDBX.Active := False;
      // Parameter setzen
      Params.Values['Database']       := edSQLiteDBPath.Text;
      Params.Values['FailIfMissing']  := 'False';
      Connected := True;
      BindSourceDBX.CommandType := ctTable;
      BindSourceDBX.CommandText := 'buecher';
      // BindSourceDBX.CommandText := 'select * from buecher;';
      BindSourceDBX.Active := True;
    End;
  Except On E: EDatabaseError Do
    ShowMessage('Fehler SQLite Datenbankverbindung: ' + E.Message);
  End;
end;


end.
