unit uaboutbox;
{
 * This Source Code Form is subject to the terms of the Mozilla Public License,
 * v. 2.0. If a copy of the MPL was not distributed with this file, You can
 * obtain one at http://mozilla.org/MPL/2.0/
 *
 * Copyright (C) 2013, Robert W.B. Linn, Pinneberg, Germany (www.rwblinn.de).
 *
 * See readme.txt for latest information.
}

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls;

type
  TfrmAboutBox = class(TForm)
    Panel1: TPanel;
    ProgramIcon: TImage;
    ProductName: TLabel;
    OKButton: TButton;
    gbLic: TGroupBox;
    memoLicTerms: TMemo;
    Image1: TImage;
    lblAuthorLabel: TLabel;
    lblAuthorName: TLabel;
    lblHomepageLabel: TLabel;
    lblHomepageURL: TLabel;
    procedure OKButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lblAuthorNameClick(Sender: TObject);
    procedure lblHomepageURLClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FAuthorName: String;
    FAuthorMailTo: String;
    FHomepageName: String;
    FHomepageURL: String;
  end;

var
  frmAboutBox: TfrmAboutBox;

implementation

{$R *.dfm}
Uses ShellAPI;

procedure TfrmAboutBox.FormCreate(Sender: TObject);
begin
//
end;

procedure TfrmAboutBox.lblAuthorNameClick(Sender: TObject);
begin
  ShellExecute(Handle, nil, PChar(FAuthorMailTo), nil, nil, SW_SHOW);
end;

procedure TfrmAboutBox.lblHomepageURLClick(Sender: TObject);
begin
  ShellExecute(Handle, nil, PChar(FHomepageURL), nil, nil, SW_SHOW);
end;

procedure TfrmAboutBox.OKButtonClick(Sender: TObject);
begin
  FrmAboutBox.Close;
end;


end.
 
