unit umain;
{
 * This Source Code Form is subject to the terms of the Mozilla Public License,
 * v. 2.0. If a copy of the MPL was not distributed with this file, You can
 * obtain one at http://mozilla.org/MPL/2.0/
 *
 * Copyright (C) 2013, Robert W.B. Linn, Pinneberg, Germany (www.rwblinn.de).
 *
 * See readme.txt for latest information.
}

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Data.DB, Data.SqlExpr,
  System.Actions, Vcl.ActnList, Data.DbxSqlite, ShellAPI, System.StrUtils,
  Vcl.Grids, Vcl.Menus, Data.FMTBcd, Vcl.ExtCtrls, Vcl.ComCtrls, Vcl.ImgList;

Const
  CCRLF = #13#10;

Const
  CPRODUCTNAME    = 'ropSQLiteIt';
  CVERSION        = 'v1.15 (Build: 20130819)';
  CAUTHORNAME     = 'Robert W.B. Linn, Pinneberg, Germany';
  CAUTHORMAILTO   = 'mailto:robert@rwblinn.de';
  CCOPYRIGHT      = 'Copyright (c) 2013, Robert W.B. Linn, Pinneberg, Germany.' + CCRLF + CCRLF +
                    'Internet: www.rwblinn.de';
  CCOPYRIGHTHTML  = '<p><div>' +
                    CPRODUCTNAME + '&nbsp;' + CVERSION +
                    ', Copyright (c) 2013 <A HREF = "http://www.rwblinn.de">Robert W.B. Linn</A>, Pinneberg, Germany.</div></p>';
  CHOMEPAGENAME   = 'www.rwblinn.de';
  CHOMEPAGEURL    = 'http://www.rwblinn.de';
  CINTERNET       = 'http://www.rwblinn.de';
  CCOMMENTS       = 'SQLite Befehlsinterpreter.';
  CINTERNETS      = 'rwblinn.de';

Type
  TfrmMain = class(TForm)
    memoSQLEditor: TMemo;
    memoOutput: TMemo;
    SQLConnection: TSQLConnection;
    ActionList: TActionList;
    ActionFileSQLiteDBConnect: TAction;
    ActionSQLExecute: TAction;
    ActionSQLResults: TAction;
    sgSQLResults: TStringGrid;
    ActionSQLResultsToStringGrid: TAction;
    ActionSQLSelectToHTML: TAction;
    ActionFileSQLiteDBOpen: TAction;
    lblSQLiteDatabase: TLabel;
    ActionOptionSQLExecuteLineByLine: TAction;
    ActionHelpAbout: TAction;
    OpenDialog1: TOpenDialog;
    splitterStringGrid: TSplitter;
    MainMenu1: TMainMenu;
    mmFile: TMenuItem;
    mmFileSQLiteDBSelectAndConnect: TMenuItem;
    N3: TMenuItem;
    ActionFileExit: TAction;
    mmFileExit: TMenuItem;
    mmHelp: TMenuItem;
    mmHelpAbout: TMenuItem;
    mmSQL: TMenuItem;
    mmSQLExecute: TMenuItem;
    mmOptions: TMenuItem;
    mmOptionsSQLExecuteLineByLine: TMenuItem;
    ActionFileSQLiteDBGetTableList: TAction;
    mmFileDBTableList: TMenuItem;
    ActionHelpHomepage: TAction;
    N1: TMenuItem;
    mmHelpHomepage: TMenuItem;
    ActionOptionSQLSelectShowDBGrid: TAction;
    ErgebnisSELECTinTabellezeigen1: TMenuItem;
    ActionHelpSQLStatements: TAction;
    N2: TMenuItem;
    KurzbersichtSQLBefehle1: TMenuItem;
    mmEDit: TMenuItem;
    ActionEditSQLResultCopy: TAction;
    Ausgabekopieren1: TMenuItem;
    sbMain: TStatusBar;
    ActionEditSQLEditorCopy: TAction;
    ActionEditSQLLogCopy: TAction;
    SQLBefehlkopieren1: TMenuItem;
    SQLBefehlslogkopieren1: TMenuItem;
    N4: TMenuItem;
    ActionEditSQLStringGridToClipboard: TAction;
    abellekopieren1: TMenuItem;
    ActionFileSQLLoadFromFile: TAction;
    mmSQLStatementLoadFromFile: TMenuItem;
    ActionFileSQLSaveToFile: TAction;
    mmSQLStatementSaveToFile: TMenuItem;
    SaveDialog1: TSaveDialog;
    ActionEditSQLEditorClear: TAction;
    SQLBefehlseditorInhaltlschen2: TMenuItem;
    ActionEditSQLResultClear: TAction;
    Ausgabelschen1: TMenuItem;
    ActionEditSQLStringGridToHTML: TAction;
    abelleHTMLspeichern1: TMenuItem;
    ActionFileSQLiteDBOpenMemory: TAction;
    N5: TMenuItem;
    Speicherdatenbankffnen1: TMenuItem;
    N8: TMenuItem;
    pnlSQL: TPanel;
    cbSQLStatementLog: TComboBox;
    N6: TMenuItem;
    ActionFileSQLiteDBClose: TAction;
    Datenbankschlieen1: TMenuItem;
    ImageList1: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure cbSQLStatementLogChange(Sender: TObject);
    procedure ActionFileSQLiteDBConnectExecute(Sender: TObject);
    procedure ActionSQLExecuteExecute(Sender: TObject);
    procedure ActionSQLResultsExecute(Sender: TObject);
    procedure ActionSQLResultsToStringGridExecute(Sender: TObject);
    procedure ActionSQLSelectToHTMLExecute(Sender: TObject);
    procedure ActionFileSQLiteDBOpenExecute(Sender: TObject);
    procedure ActionOptionSQLExecuteLineByLineExecute(Sender: TObject);
    procedure ActionHelpAboutExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cbSQLStatementLogDblClick(Sender: TObject);
    procedure cbSQLStatementLogDropDown(Sender: TObject);
    procedure cbSQLStatementLogKeyPress(Sender: TObject; var Key: Char);
    procedure ActionFileExitExecute(Sender: TObject);
    procedure ActionFileSQLiteDBGetTableListExecute(Sender: TObject);
    procedure ActionHelpHomepageExecute(Sender: TObject);
    procedure ActionOptionSQLSelectShowDBGridExecute(Sender: TObject);
    procedure lblSQLiteDatabaseClick(Sender: TObject);
    procedure ActionHelpSQLStatementsExecute(Sender: TObject);
    procedure ActionEditSQLResultCopyExecute(Sender: TObject);
    procedure ActionEditSQLEditorCopyExecute(Sender: TObject);
    procedure ActionEditSQLLogCopyExecute(Sender: TObject);
    procedure ActionEditSQLStringGridToClipboardExecute(Sender: TObject);
    procedure ActionFileSQLLoadFromFileExecute(Sender: TObject);
    procedure ActionFileSQLSaveToFileExecute(Sender: TObject);
    procedure ActionEditSQLResultClearExecute(Sender: TObject);
    procedure ActionEditSQLEditorClearExecute(Sender: TObject);
    procedure ActionEditSQLStringGridToHTMLExecute(Sender: TObject);
    procedure ActionFileSQLiteDBOpenMemoryExecute(Sender: TObject);
    procedure mmSQLClick(Sender: TObject);
    procedure ActionFileSQLiteDBCloseExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FIniFile: String;         // ropSQLite Inidatei mit Einstellungen
    FDB: String;              // SQLite Datenbank mit Pfad
    FSQLCommandText: String;
    FSQLDataSet: TDataSet;
    Function DatasetRecordCount(DS: TDataSet): Integer;
  end;

var
  frmMain: TfrmMain;

implementation

Uses UMisc, UAboutBox;

Const
  CSQLITEDBMEMORY = ':memory:';
  CHELPSQLSAMPLES =
    'Kurzbersicht SQL Befehle' + CCRLF +
    'CREATE TABLE Tabelle (Spalte1 Typ, SpalteN Typ);' + CCRLF +
    'INSERT INTO Tabelle (Spalte1, SpalteN) VALUES (Wert1, WertN);' + CCRLF +
    'INSERT INTO Tabelle (Spalte1, SpalteN) VALUES (:Spalte1, :SpalteN);' + CCRLF +
    'SELECT Spalten FROM Tabelle(n) WHERE Bedingung ORDER BY Sortierung GROUP BY Gruppierung HAVING Einschrnkung;' + CCRLF +
    'SELECT * FROM Tabelle;' + CCRLF +
    'UPDATE Tabelle SET Spalte1=Wert, SpalteN=Wert WHERE Spalte=Bedingung;' + CCRLF +
    'DELETE FROM Tabelle;' + CCRLF +
    'DROP TABLE Tabelle;' + CCRLF +
    'CREATE INDEX Index ON Tabelle(Spalte);' + CCRLF +
    'DROP INDEX Index;' + CCRLF +
    'CREATE VIEW View AS SELECT Befehl;' + CCRLF +
    'DROP VIEW View;' + CCRLF +
    'CREATE TRIGGER Trigger AFTER Aktion ON Tabelle BEGIN Ereignis; END;' + CCRLF +
    'DROP VIEW View;' + CCRLF +
    'PRAGMA database_list;' + CCRLF +
    'PRAGMA table_info (Tabelle);' + CCRLF +
    'PRAGMA index_list (Tabelle);' + CCRLF +
    'PRAGMA index_info (Index);' + CCRLF +
    'SELECT * FROM sqlite_master;' + CCRLF +
    'SELECT tbl_name AS Tabelle FROM sqlite_master WHERE type = "table";' + CCRLF +
    '';

Var
  nSQLStatementLogIdx: Integer;

{$R *.dfm}
//******************************************************************************
// FORM
//******************************************************************************
procedure TfrmMain.FormCreate(Sender: TObject);
begin
  // Initialisierungen
  // Stringgrid SELECT Ergebnis nicht zeigen
  sgSQLResults.Visible := False;
  splitterStringGrid.Visible := sgSQLResults.Visible;
  ActionFileSQLiteDBClose.Enabled := False;
  // SQLBefehlslogger alle Eintrge lschen
  cbSQLStatementLog.Clear;
  // Inidatei zuweisen
  FIniFile := ChangeFileExt(Application.ExeName, '.ini');
  // Inidatei Werte lesen
  // SQL Befehl Zeile fr Zeile ausfhren
  ActionOptionSQLExecuteLineByLine.Checked :=
    (IniGetValue(FIniFile, 'Settings', 'SQLExecuteByLine', '0') = '1');
  // StringGrid zeigen nach Ausfhrung SELECT Befehls
  ActionOptionSQLSelectShowDBGrid.Checked :=
    (IniGetValue(FIniFile, 'Settings', 'SQLSelectShowDBGrid', '0') = '1');
  // SQLite Datenbank
  FDB := IniGetValue(FIniFile, 'Settings', 'SQLiteDB', '');
  // Prfen ob Datenbank vorhanden ist
  If FileExists(FDB) Then Begin
    // SQL Verbindung mit der SQLite Datenbank herstellen
    ActionFileSQLiteDBConnectExecute(Sender);
  End
  Else Begin
    //
    memoOutput.Text := DateTimeToStr(Now) + ' :: SQLConnection Fehler: ' + CCRLF +
                       'Datenbank nicht gefunden - ' + FDB;
  End;
end;

procedure TfrmMain.FormShow(Sender: TObject);
begin
  With memoSQLEditor Do Begin
    SetFocus;
    Text := '<SQL Befehl>';
    SelStart:=0;
    SelLength:=Length(Text);
  End;
end;

procedure TfrmMain.lblSQLiteDatabaseClick(Sender: TObject);
Var LMsg: String;
    i: Integer;
begin
  LMsg := '';
  LMsg := LMsg + 'Name: ' + SQLConnection.Name + CCRLF;
  If SQLConnection.Connected Then
    LMsg := LMsg + 'Verbunden: Ja' + CCRLF
  Else
    LMsg := LMsg + 'Verbunden: Nein' + CCRLF;
  If SQLConnection.KeepConnection Then
    LMsg := LMsg + 'Verbunden bleiben: Ja' + CCRLF
  Else
    LMsg := LMsg + 'Verbunden bleiben: Nein' + CCRLF;
  If SQLConnection.LoginPrompt Then
    LMsg := LMsg + 'Login: Ja' + CCRLF
  Else
    LMsg := LMsg + 'Login: Nein' + CCRLF;
  LMsg := LMsg + 'Parameter:' + CCRLF;
  For i := 0 To SQLConnection.Params.Count - 1 Do Begin
    LMsg := LMsg + ' ' + SQLConnection.Params[i] + CCRLF;
  End;
  Application.MessageBox(
    PChar(LMsg),
    PChar('SQL Connection Eigenschaften'),
    MB_OK + MB_ICONINFORMATION);
end;

procedure TfrmMain.mmSQLClick(Sender: TObject);
begin
  ActionSQLExecuteExecute(Sender);
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  // Inidatei Werte speichern
  // SQL Befehl Zeile fr Zeile ausfhren
  If ActionOptionSQLExecuteLineByLine.Checked Then
    IniSetValue(FIniFile, 'Settings', 'SQLExecuteByLine', '1')
  Else
    IniSetValue(FIniFile, 'Settings', 'SQLExecuteByLine', '0');
  // StringGrid zeigen nach Ausfhrung SELECT Befehls
  If ActionOptionSQLSelectShowDBGrid.Checked Then
    IniSetValue(FIniFile, 'Settings', 'SQLSelectShowDBGrid', '1')
  Else
    IniSetValue(FIniFile, 'Settings', 'SQLSelectShowDBGrid', '0');
  // SQLite Datenbank
  IniSetValue(FIniFile, 'Settings', 'SQLiteDB', FDB);
end;

//******************************************************************************
// ACTIONS
//******************************************************************************
procedure TfrmMain.ActionEditSQLResultClearExecute(Sender: TObject);
begin
  memoOutput.Lines.Clear;
end;

procedure TfrmMain.ActionEditSQLEditorClearExecute(Sender: TObject);
begin
  memoSQLEditor.Lines.Clear;
end;

procedure TfrmMain.ActionEditSQLResultCopyExecute(Sender: TObject);
begin
  StrToClipboard(memoOutput.Text);
end;

procedure TfrmMain.ActionEditSQLEditorCopyExecute(Sender: TObject);
begin
  StrToClipboard(memoSQLEditor.Text);
end;

procedure TfrmMain.ActionEditSQLLogCopyExecute(Sender: TObject);
begin
  StrToClipboard(cbSQLStatementLog.Items.Text);
end;

procedure TfrmMain.ActionEditSQLStringGridToClipboardExecute(Sender: TObject);
// Inhalt Stringgrid zur Zwischenablage
Var
  sStr, sRow: String;
  nRow, nCol: Integer;
Begin
  sStr := '';
  If NOT Visible Then Exit;
  If sgSQLResults.RowCount < 1 Then Exit;
  If sgSQLResults.ColCount < 1 Then Exit;
  For nRow := 0 To sgSQLResults.RowCount - 1 Do Begin
    sRow := '';
    For nCol := 1 To sgSQLResults.ColCount - 1 Do Begin
        sRow := sRow + sgSQLResults.Cells[nCol, nRow];
        If nCol < sgSQLResults.ColCount - 1 Then sRow := sRow + ', ';
    End;
    sStr := sStr + sRow + CCRLF;
  End;
  StrToClipboard(sStr);
end;

procedure TfrmMain.ActionEditSQLStringGridToHTMLExecute(Sender: TObject);
// Ergebnis SQL Select in HTML Tabelle ausgeben und im
// Standardbrowser zeigen
Const
  CCRLF = #13#10;
  CHTMLCSS    = '<style type='''+ 'text/css' + '''>' + CCRLF +
                'table { width:100%; background-color:#D7E4F2; border:1px; } '+ CCRLF +
                'h1 { font:bold 1.4em Arial; color:#000080; background-color:#; border:1px; solid #000; vertical-align:top; overflow:hidden; }' + CCRLF +
                'th { font:bold 1.2em Arial; color:#000080; background-color:#F0F8FF; border:1px; solid #000; vertical-align:top; overflow:hidden; }' + CCRLF +
                'td { font:normal 0.8em Arial; color:#000000; background-color:#; border:1px; solid #000; vertical-align:top; overflow:hidden; }' + CCRLF +
                'p { font:normal 0.6em Arial; color:#000080; background-color:#; border:1px; solid #000; text-align:left; vertical-align:top; overflow:hidden; }' + CCRLF +
                'div { font:normal 0.6em Arial; color:#000080; background-color:#; border:1px; solid #000; text-align:center; vertical-align:top; overflow:hidden; }' + CCRLF +
                '</style>';
  CHTMLB      = '<HTML>' + CCRLF + '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN">' + CCRLF +
                '<HEAD>' + CCRLF+ CHTMLCSS + CCRLF +
                '</HEAD><BODY bgcolor=#FFFFFF>';
  CHTMLTABLEB = '<TABLE>';
  CHTMLTABLEE = '</TABLE>';
  CHTMLE      = '</BODY></HTML>';
  //CHTMLE      = '<p><div>Erstellt mittels ropSQLiteIt (c) 2013 Robert W.B. Linn, Pinnberg, Germany</div></p></BODY></HTML>';
Var fSL: TStringList;
    sFile: String;
    nRow, nCol: Integer;
Begin
  sFile := ExtractFilePath(Application.ExeName) + 'tabelle.htm';
  fSL := TStringList.Create;
  fSL.Add(CHTMLB);
  fSL.Add('<H1>' + memoSQLEditor.Text + '</H1>');
  fSL.Add(CHTMLTABLEB);
  If NOT sgSQLResults.Visible Then Exit;
  If sgSQLResults.RowCount < 1 Then Exit;
  If sgSQLResults.ColCount < 1 Then Exit;
  // Row 0 = Spaltenberschrift - Feldnamen
  nRow := 0;
  fSL.Add('<TR>');
  For nCol := 1 To sgSQLResults.ColCount - 1 Do
    fSL.Add('<TH>' + sgSQLResults.Cells[nCol, nRow] + '</TH>');
  fSL.Add('</TR>');
  // Row > 0 = Spalteninhalte
  For nRow := 1 To sgSQLResults.RowCount - 1 Do Begin
    fSL.Add('<TR>');
    For nCol := 1 To sgSQLResults.ColCount - 1 Do Begin
      If sgSQLResults.Cells[nCol, nRow] = '' Then
        fSL.Add('<TD>' +  '&nbsp;' + '</TD>')
      Else
        fSL.Add('<TD>' + sgSQLResults.Cells[nCol, nRow] + '</TD>');
    End;
    fSL.Add('</TR>');
  End;
  fSL.Add(CHTMLTABLEE + '<p>' + DateTimeToStr(Now) + '</p>');
  fSL.Add(CCOPYRIGHTHTML);
  fSL.Add(CHTMLE);
  fSL.SaveToFile(sFile);
  ShellExecute(Handle, nil, PChar(sFile), nil, nil, SW_SHOW);
end;

procedure TfrmMain.ActionFileExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.ActionFileSQLiteDBCloseExecute(Sender: TObject);
begin
  Try
    If NOT SQLConnection.Connected Then Exit;
    SQLConnection.Connected := False; // Is the same as .Close;
  Except
    on E: EDatabaseError do
      memoOutput.Text := DateTimeToStr(Now) + ' :: SQLConnection Fehler: ' + CCRLF + E.Message;
  End;
end;

procedure TfrmMain.ActionFileSQLiteDBConnectExecute(Sender: TObject);
Var i : Integer;
begin
  ActionFileSQLiteDBClose.Enabled := False;
  If (FDB = '') Then Begin
    memoOutput.Text := DateTimeToStr(Now) + ' :: SQLConnection Fehler: ' + CCRLF +
                       'Kein Datenbankname angegeben.';
    Exit;
  End;
  sgSQLResults.Visible := False;
  splitterStringGrid.Visible := sgSQLResults.Visible;
  Try
    SQLConnection.Connected := False;
    SQLConnection.Params.Clear;
    SQLConnection.Params.Add('ColumnMetaDataSupported=True');
    SQLConnection.Params.Add('FailIfMissing=False');
    SQLConnection.Params.Add('Database=' + FDB);
    lblSQLiteDatabase.Caption := 'Datenbank: ' + FDB;
    SQLConnection.Connected := True;
    ActionFileSQLiteDBClose.Enabled := True;
    memoOutput.Text :=  DateTimeToStr(Now) +
                        ' :: SQLite Datenbank Verbindung hergestellt.' + CCRLF +
                        'Parameter:';
    For i := 0 To SQLConnection.Params.Count - 1 Do
      memoOutput.Lines.Add(SQLConnection.Params[i]);
  Except
    on E: EDatabaseError do
      memoOutput.Text := DateTimeToStr(Now) + ' :: SQLConnection Fehler: ' + CCRLF + E.Message;
  end;
end;

procedure TfrmMain.ActionFileSQLiteDBOpenExecute(Sender: TObject);
begin
  OpenDialog1.FileName := FDB;
  OpenDialog1.Filter := 'SQLite Datenbank (*.db)|*.db;*.db3;*.sqlite|Alle Dateien (*.*)|*.*';
  If OpenDialog1.Execute Then Begin
    FDB := OpenDialog1.FileName;
    ActionFileSQLiteDBConnectExecute(Sender);
  End;
end;

procedure TfrmMain.ActionFileSQLiteDBOpenMemoryExecute(Sender: TObject);
begin
  FDB := CSQLITEDBMEMORY;
  ActionFileSQLiteDBConnectExecute(Sender);
end;

procedure TfrmMain.ActionSQLExecuteExecute(Sender: TObject);
Var i: Integer;   // Zeilencounter fr SQL Befehl LineByLine
Begin
  sgSQLResults.Visible := False;
  splitterStringGrid.Visible := sgSQLResults.Visible;
  If memoSQLEditor.Text = '' Then Exit;
  Try
    If NOT SQLConnection.Connected Then Exit;
  Except On E: Exception Do Begin
      memoOutput.Text := DateTimeToStr(Now) + ' :: SQL: ' + memoSQLEditor.Text + #13#10 + 'SQL Befehl Fehler: ' + #13#10 + E.Message;
      Exit;
    End;
  End;
  cbSQLStatementLog.Text := memoSQLEditor.Text;
  cbSQLStatementLogDropDown(Sender);
  memoOutput.Clear;
  // SQL Befehl direkt ausfhren
  If NOT ActionOptionSQLExecuteLineByLine.Checked Then Begin
    Try
      FSQLCommandText := memoSQLEditor.Text;
      memoOutput.Lines.Add(DateTimeToStr(Now) + ' :: SQL: ' + FSQLCommandText);
      If (LeftStr(LowerCase(FSQLCommandText), Length('select')) = 'select') Or
         (LeftStr(LowerCase(FSQLCommandText), Length('pragma')) = 'pragma') Then Begin
        // SQL select query mit Ergebnis anzeigen im Memo ggf. Stringgrid
        SQLConnection.Execute(FSQLCommandText, NIL, FSQLDataSet);
        memoOutput.Lines.Add(DateTimeToStr(Now) + ' :: SQL: ausgefhrt.');
        ActionSQLResultsExecute(Sender);
      End
      Else Begin
        // SQL non select Befehl liefert kein Resultat, wie create table, drop table, insert into, delete, update
        SQLConnection.ExecuteDirect(FSQLCommandText);
      End;
    Except On E: Exception Do Begin
        memoOutput.Text := DateTimeToStr(Now) + ' :: SQL: ' + memoSQLEditor.Text + CCRLF +
                           'SQL Befehl Fehler: ' + CCRLF + E.Message;
        Exit;
      End;
    End;
  End;
  // SQL Befehl Line by Line ausfhren
  If ActionOptionSQLExecuteLineByLine.Checked Then Begin
    memoOutput.Lines.Clear;
    For i := 0 To memoSQLEditor.Lines.Count - 1 Do Begin
      If (memoSQLEditor.Lines[i] <> '') And
         (LeftStr(memoSQLEditor.Lines[i], 1) <> ';') Then Begin
        Try
          FSQLCommandText := memoSQLEditor.Lines[i];
          memoOutput.Lines.Add(DateTimeToStr(Now) + ' :: SQL: ' + FSQLCommandText);
          If (LeftStr(LowerCase(FSQLCommandText), Length('select')) = 'select') OR
             (LeftStr(LowerCase(FSQLCommandText), Length('pragma')) = 'pragma') Then Begin
             // SQL select query mit Ergebnis anzeigen im Memo ggf. Stringgrid
            SQLConnection.Execute(FSQLCommandText, NIL, FSQLDataSet);
            memoOutput.Lines.Add(DateTimeToStr(Now) + ' :: SQL: ausgefhrt.');
            ActionSQLResultsExecute(Sender);
          End
          Else Begin
            // SQL non select Befehl liefert kein Resultat, wie create table, drop table, insert into, delete, update
            SQLConnection.ExecuteDirect(FSQLCommandText);
          End;
        Except On E: Exception Do Begin
            memoOutput.Text := DateTimeToStr(Now) + ' :: SQL Befehl Fehler: ' + CCRLF + E.Message;
            Exit;
          End;
        End;
      End;
    End;
  End;
end;

procedure TfrmMain.ActionFileSQLLoadFromFileExecute(Sender: TObject);
Var fSL: TStringList;
begin
  OpenDialog1.FileName := '*.sql';
  OpenDialog1.Filter := 'SQL Befehlsdatei (*.sql)|*.sql|Alle Dateien (*.*)|*.*';
  If OpenDialog1.Execute Then Begin
    fSL := TStringList.Create;
    fSL.LoadFromFile(OpenDialog1.FileName);
    memoSQLEditor.Lines.Text := fSL.Text;
    // memoSQLEditor.Lines.Add(fSL.Text);
    fSL.Free;
  End;
End;

procedure TfrmMain.ActionFileSQLSaveToFileExecute(Sender: TObject);
begin
  If memoSQLEditor.Text = '' Then Exit;
  SaveDialog1.FileName := '*.sql';
  If SaveDialog1.Execute Then
    memoSQLEditor.Lines.SaveToFile(SaveDialog1.Filename);
end;

procedure TfrmMain.ActionOptionSQLExecuteLineByLineExecute(Sender: TObject);
begin
  // ActionSQLExecuteLineByLineOption.Checked := NOT ActionSQLExecuteLineByLineOption.Checked;
end;

procedure TfrmMain.ActionSQLResultsExecute(Sender: TObject);
Var
  fSLNames: TStringList;  // Liste Feldnamen Tabelle
  i: Integer;             // Laufvariable
  currentField: TField;   // Aktuelle Feld
  currentLine: String;    // Aktuelle Memozeile mit Feldergebnis
  nCnt: Integer;          // Recordcounter
Begin
  sgSQLResults.Visible := False;
  splitterStringGrid.Visible := sgSQLResults.Visible;
  Try
    If FSQLDataSet = NIL Then Exit;
    If FSQLDataSet.IsEmpty Then Begin
      memoOutput.Lines.Add(DateTimeToStr(Now) + ' :: Keine Datenstze gefunden.');
      Exit;
    End;
    nCnt := DatasetRecordCount(FSQLDataSet);
  Except
    On E: EDatabaseError Do Begin
      memoOutput.Text := DateTimeToStr(Now) + ' :: SQLConnection Fehler: ' + CCRLF + E.Message;
      Exit;
    End;
  End;
  // Check ob SELECT oder PRAGMA Befehl
  // SELECT
  If (LeftStr(LowerCase(FSQLCommandText), Length('select')) = 'select') Then Begin
    memoOutput.Lines.Add(DateTimeToStr(Now) + ' :: Anzahl Datenstze: ' + IntToStr(nCnt));
    fSLNames := TStringList.Create;         // Liste der Feldnamen initialisieren
    FSQLDataSet.GetFieldNames(fSLNames);  // Feldnamen lesen aus Ergebnisdataset
    currentLine := '(';                     // Feldnamen als berschrift zeigen
    For i := 0 To fSLNames.Count - 1 Do Begin
      currentLine := currentLine + fSLNames[i];
      If i < fSLNames.Count - 1 Then currentLine := currentLine + '; ';
    End;
    currentLine := currentLine + ')';
    memoOutput.Lines.Add(currentLine);   // Feldnamen anzeigen
    FSQLDataSet.First;                    // Ergebnis Satz fr Satz lesen
    While NOT FSQLDataSet.Eof Do Begin
      currentLine := '';
      For i := 0 To fSLNames.Count - 1 Do Begin
        currentField := FSQLDataSet.FieldByName(fSLNames[i]);
        currentLine := currentLine + currentField.AsString;
        If i < fSLNames.Count - 1 Then currentLine := currentLine + '; ';
      End;
      memoOutput.Lines.Add(currentLine); // Datensatz anzeigen
      FSQLDataSet.Next;
    End;
    fSLNames.Free;
    ActionSQLResultsToStringGridExecute(Sender);
  End;
  // PRAGMA
  If (LeftStr(LowerCase(FSQLCommandText), Length('pragma')) = 'pragma') Then Begin
    memoOutput.Lines.Add('(Spaltennr, Spaltenname, Data Type, NOT NULL, Vorgabewert)');
    FSQLDataSet.First;
    While NOT FSQLDataSet.Eof Do Begin
      currentLine := '';
      // Hole alle Infos aus dem datensatz
      // Beispiel pragma table_info(Tabelle) liefert
      // column name, data type, whether or not the column can be NULL, and the default value for the column
      For i := 0 to FSQLDataSet.FieldCount-1 do
        currentLine := currentLine + ' ' + FSQLDataSet.Fields[i].AsString;
      memoOutput.Lines.Add(currentLine); // Datensatz anzeigen
      FSQLDataSet.Next;
    End;
  End;
  // Setze Fokus auf Memo Output erste Position
  With memoOutput Do Begin
    SetFocus;
    SelStart:=0;
    SelLength:=0;
  End;
End;

procedure TfrmMain.ActionSQLResultsToStringGridExecute(Sender: TObject);
// Ergebnis SQL Select Befehl im StringGrid zeigen
Var
  nCol, nLin, nColW: Integer;
Begin
  If ActionOptionSQLSelectShowDBGrid.Checked = False Then
    Exit;
  // Datenstze gefunden = Zeigen
  If FSQLDataSet.IsEmpty Then Exit;
  sgSQLResults.Visible := True;
  splitterStringGrid.Visible := sgSQLResults.Visible;
  sgSQLResults.ColCount := FSQLDataSet.FieldCount + 1;
  sgSQLResults.RowCount := DatasetRecordCount(FSQLDataSet) + 1;
  sgSQLResults.FixedCols := 1;
  sgSQLResults.FixedRows := 1;
  // Spaltenbreite anpassen - erste spalte ist fix = 32
  nColW := 64;
  If sgSQLResults.ColCount > 1 Then Begin
    sgSQLResults.ColWidths[0] := 32;
    nColW := Round((sgSQLResults.Width - 48) / (sgSQLResults.ColCount - 1));
  End;
  // Spaltenberschriften setzen
  For nCol := 0 To FSQLDataSet.FieldCount - 1 Do Begin
    sgSQLResults.Cells[nCol + 1, 0] := FSQLDataSet.Fields[nCol].FieldName;
    sgSQLResults.ColWidths[nCol + 1] := nColW;
  End;
  nLin := 0;
  // Daten im Stringgrid zeigen
  FSQLDataSet.First;
  While NOT FSQLDataSet.EOF Do Begin
    // Hier kann ein Counter in der Fixspalte definiert werden
    // sgSQLResults.Cells[0, nLin + sgSQLResults.FixedRows] := IntToStr(nLin + 1);
    For nCol := 0 To FSQLDataSet.FieldCount - 1 Do Begin
      sgSQLResults.Cells[nCol + 1, nLin + sgSQLResults.FixedRows] :=
        FSQLDataSet.Fields[nCol].AsString;
    End;
    FSQLDataSet.Next;
    Inc(nLin);
  End;
End;

procedure TfrmMain.ActionSQLSelectToHTMLExecute(Sender: TObject);
// Ergebnis SQL Select in HTML Tabelle ausgeben und im
// Standardbrowser zeigen
Const
  CCRLF = #13#10;
  CHTMLCSS    = '<style type='''+ 'text/css' + '''>' + CCRLF +
                'table { width:100%; background-color:#D7E4F2; border:1px; } '+ CCRLF +
                'h1 { font:bold 1.4em Arial; color:#000080; background-color:#; border:1px; solid #000; vertical-align:top; overflow:hidden; }' + CCRLF +
                'th { font:bold 1.2em Arial; color:#000080; background-color:#F0F8FF; border:1px; solid #000; vertical-align:top; overflow:hidden; }' + CCRLF +
                'td { font:normal 0.8em Arial; color:#000000; background-color:#; border:1px; solid #000; vertical-align:top; overflow:hidden; }' + CCRLF +
                'p { font:normal 0.6em Arial; color:#000080; background-color:#; border:1px; solid #000; text-align:left; vertical-align:top; overflow:hidden; }' + CCRLF +
                'div { font:normal 0.6em Arial; color:#000080; background-color:#; border:1px; solid #000; text-align:center; vertical-align:top; overflow:hidden; }' + CCRLF +
                '</style>';
  CHTMLB      = '<HTML>' + CCRLF + '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN">' + CCRLF +
                '<HEAD>' + CCRLF+ CHTMLCSS + CCRLF +
                '</HEAD><BODY bgcolor=#FFFFFF>';
  CHTMLTABLEB = '<TABLE>';
  CHTMLTABLEE = '</TABLE>';
  CHTMLE      = '</BODY></HTML>';
  //CHTMLE      = '<p><div>Erstellt mittels ropSQLiteIt (c) 2013 Robert W.B. Linn, Pinnberg, Germany</div></p></BODY></HTML>';

Var DS: TDataSet;
    fSL: TStringList;
    sFile: String;
    i: Integer;
    sField: String;
Begin
  // SQL direkt ausfhren
  DS := NIL;
  Try
    SQLConnection.Execute(memoSQLEditor.Text, NIL, DS);
  Except
    On E: Exception Do Begin
      memoOutput.Text := DateTimeToStr(Now) + ' :: SQL Befehl Fehler: ' + CCRLF + E.Message;
      Exit;
    End;
  End;
  If DS.IsEmpty Then Exit;
  sFile := ExtractFilePath(Application.ExeName) + 'tabelle.htm';
  fSL := TStringList.Create;
  fSL.Add(CHTMLB);
  fSL.Add('<H1>' + memoSQLEditor.Text + '</H1>');
  fSL.Add(CHTMLTABLEB);
  // Spaltenberschrift - Feldnamen
  fSL.Add('<TR>');
  For i := 0 To DS.FieldCount - 1 Do
    fSL.Add('<TH>' + DS.Fields[i].FieldName + '</TH>');
  fSL.Add('</TR>');
  // Inhalt Tabelle ausgeben
  DS.First;
  While Not DS.Eof Do Begin
    fSL.Add('<TR>');
    For i := 0 To DS.FieldCount - 1 Do Begin
      sField := DS.Fields[i].AsString;
      If sField = '' Then sField := '&nbsp;';
      fSL.Add('<TD>' + sField + '</TD>');
    End;
    DS.Next;
    fSL.Add('</TR>');
  End;
  fSL.Add(CHTMLTABLEE + '<p>' + DateTimeToStr(Now) + '</p>');
  fSL.Add(CCOPYRIGHTHTML);
  fSL.Add(CHTMLE);
  fSL.SaveToFile(sFile);
  ShellExecute(Handle, nil, PChar(sFile), nil, nil, SW_SHOW);
End;

procedure TfrmMain.ActionFileSQLiteDBGetTableListExecute(Sender: TObject);
begin
  // Tabellen auflisten
  memoSQLEditor.Text := 'SELECT * FROM sqlite_master WHERE type = "table";';
  //memoSQLEditor.Text := 'SELECT tbl_name FROM sqlite_master WHERE type = "table"';
  ActionSQLExecuteExecute(Sender);
end;

procedure TfrmMain.cbSQLStatementLogChange(Sender: TObject);
begin
  nSQLStatementLogIdx := cbSQLStatementLog.ItemIndex;
  memoSQLEditor.Text := cbSQLStatementLog.Text;
end;

procedure TfrmMain.cbSQLStatementLogDblClick(Sender: TObject);
Var Key: Char;
begin
  Key := #13;
  cbSQLStatementLogKeyPress(Sender, Key);
end;

procedure TfrmMain.cbSQLStatementLogDropDown(Sender: TObject);
Var i : Integer;
begin
  If cbSQLStatementLog.Text = '' Then Begin
    cbSQLStatementLog.Items.Delete(nSQLStatementLogIdx);
      nSQLStatementLogIdx := -1;
  End
  Else Begin
    For i := 0 To cbSQLStatementLog.Items.Count - 1 Do
      If Text = cbSQLStatementLog.Items[i] Then Exit;
        cbSQLStatementLog.Items.Add(Text);
  End;
end;

procedure TfrmMain.cbSQLStatementLogKeyPress(Sender: TObject; var Key: Char);
begin
  If Key = #13 Then Begin
    cbSQLStatementLogDropDown(Sender);
    memoSQLEditor.Text := cbSQLStatementLog.Text;
  End;
end;

Function TfrmMain.DatasetRecordCount(DS: TDataSet): Integer;
// Anzahl Datenstze zurckgeben
Var i : Integer;
Begin
  Result := 0;
  If DS = NIL Then Exit;
  If DS.IsEmpty Then Exit;
  i := 0;
  DS.First;
  While Not DS.Eof Do Begin
    i := i + 1;
    DS.Next;
  End;
  Result := i;
End;

procedure TfrmMain.ActionHelpHomepageExecute(Sender: TObject);
begin
  ShellExecute(Handle, nil, PChar('http://www.rwblinn.de'), nil, nil, SW_SHOW);
end;

procedure TfrmMain.ActionHelpSQLStatementsExecute(Sender: TObject);
begin
  sgSQLResults.Visible := False;
  splitterStringGrid.Visible := sgSQLResults.Visible;
  memoOutput.Text := CHELPSQLSAMPLES;
end;

procedure TfrmMain.ActionOptionSQLSelectShowDBGridExecute(Sender: TObject);
begin
  //
end;

procedure TfrmMain.ActionHelpAboutExecute(Sender: TObject);
begin
  With TfrmAboutBox.Create(nil) do
    Try
      Caption := 'About...';
      ProductName.Caption   := CPRODUCTNAME + ' ' + CVERSION;
      FAuthorName   := CAUTHORNAME;
      FAuthorMailTo := CAUTHORMAILTO;
      FHomepageName := CHOMEPAGENAME;
      FHomepageURL  := CHOMEPAGEURL;
      lblAuthorName.Caption := FAuthorName;
      lblHomepageURL.Caption := FHomepageName;
      ShowModal;
    Finally
      Free;
    End;
end;

end.

