unit umisc;
{******************************************************************************}
{ This file is part of ropSQLiteIt Application                                 }
{                                                                              }
{ Copyright (c) 2013 Robert W.B. Linn, Pinneberg, Germany                      }
{                                                                              }
{ This is free software: you can redistribute it and/or modify it under        }
{ the terms of the GNU General Public License as published by the Free Software}
{ Foundation, either version 3 of the License, or (at your option) any later   }
{ version. This application is distributed WITHOUT ANY WARRANTY; without even  }
{ the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. }
{ See the GNU General Public License for more details.                         }
{ You should have received a copy of the GNU General Public License along with }
{ this application. If not, www.gnu.org/licenses/.                             }
{                                                                              }
{ Author: Robert W.B. Linn, Pinneberg, Germany                                 }
{ Internet/E-Mail: www.rwblinn.de , robert@rwblinn.de                          }
{ Read readme.txt for latest information                                       }
{                                                                              }
{******************************************************************************}

interface
//*****************************************************************************
//USES
//*****************************************************************************
Uses Clipbrd, IniFiles;

  // INI
  Function  IniGetValue(sFile, sSection, sKey, sDefault: String ) : String;
  Function  IniSetValue(sFile, sSection, sKey, sValue : String): Integer;

  // CLIPBOARD
  Procedure ClearClipboard;
  Procedure StrToClipboard(sStr : String);
  Function  ClipboardToStr : String;

implementation

//******************************************************************************
// INI
//******************************************************************************
Function IniGetValue(sFile, sSection, sKey, sDefault: String ) : String;
// Ini string aus ini datei lesen
Var
  TheIni : TIniFile;
  sTmp : String;
Begin
  TheIni := TIniFile.Create(sFile);
  Try
    sTmp := TheIni.ReadString(sSection, sKey, sDefault);
    //If sTmp = '' Then sTmp := sKey;
  Finally
    TheIni.Free;
  End;
	Result := sTmp;
End;

Function IniSetValue(sFile, sSection, sKey, sValue : String): Integer;
// wert in eine ini datei setzen
Var
  TheIni : TIniFile;
Begin
  TheIni := TIniFile.Create(sFile);
  Try
    Try
      TheIni.WriteString(sSection, sKey, sValue);
      Result := 1;
    Except
      Result := 0;
    End;
  Finally
    TheIni.UpdateFile;
    TheIni.Free;
  End;
End;

//******************************************************************************
// CLIPBOARD
//******************************************************************************
Procedure ClearClipboard;
Begin
  Clipboard.Clear;
End;

procedure StrToClipboard(sStr : String);
Begin
	If sStr <> '' Then
		ClipBoard.SetTextBuf(PChar(sStr))
  Else
    Clipboard.Clear;
End;

Function ClipboardToStr : String;
begin
	Result := '';
  Result := Clipboard.AsText;
end;

end.
